
        .MODEL  SMALL
        .STACK  512

;#########################################################################################################################

        .CONST

        .DATA

	color db 02
	lado dw 0
	nivel dw 200
	inicio dw 32h
	coluna dw 96h
	linha dw 10h
	quedas dw 180
	cont db 0h
	frase1 db ' ','$'

        .DATA?

;#########################################################################################################################

        .CODE

myproc  PROC    FAR

;initialize the data segment

		mov     ax,@DATA
        mov     ds,ax
	
		
		mov 	ax, 04  	;modo graf 320x200 color mode
		int 	10h			;invoca a int 10h da BIOS	
	
		mov 	ah,11		;prepara configurao da palete de cores
		mov 	bh,00		;inicializa a cor de background
		mov 	bl,01		;background azul
		int 	10h			;invoca a interrupo 10h da BIOS
	
	
		mov 	ah,11		;prepara configurao da palete de cores
		mov 	bh,01		;prepara conf do foreground
		mov 	bl,00		;verde,vermelho e amarelo
		int 	10h			;invoca a intrrupo 10h 10 da Bios
	
quad:
		mov     quedas,180     ;falls = 180
        push    ax
        push    bx
        push    dx
        push    ds
        xor     ax,ax
        mov     ds,ax
        lds     ax,ds:[46Ch]
        mov     dx,ds
        mov     bx,301
        pop     ds
        div     bx
        mov     coluna,dx
        pop     dx
        pop     bx
        pop     ax
		
;desenhar o primeiro rectangulo
		push 	ax
		push 	bx
		push 	dx
		push 	cx		
quad1:
		cmp 	quedas,0
		je 		quad
		call 	pixel
		mov 	dx,98h		;selecciona a linha 100
		mov 	cx,inicio	;selecciona a coluna 158
		call 	proc1

here:

		call 	pixel
		push 	dx
		mov 	ah,6  		;apenas espera
		mov 	dl,0ffh
		int 	21h			;por outra tecla
		pop 	dx
		cmp 	al, 6eh		;se for igual a tecla n vai apagar quadrado
		je 		apaga
		cmp 	al,6dh		;se for igual a tecla m vai apagar quadrado
		je 		apaga
		cmp 	al, 31h		;se for igual a tecla n vai apagar quadrado
		je 		nivel1
nivel1:	mov 	nivel,20	;se carrega na tecla 1 a bola anda a 200 milisegundos
		cmp 	al, 32h		;se for igual a tecla n vai apagar quadrado
		je 		nivel2
nivel2:	mov 	nivel,500	;se carrega na tecla 2 a bola anda a 500 milisegundos	
		cmp 	al,0dh		;se for ENTER sai do programa
		je 		fim
		push 	dx
		mov 	ah,6  		;apenas espera
		mov 	dl,0ffh
		int 	21h			;por outra tecla
		pop 	dx
		cmp 	al, 0dh		;enquanto for diferente de ENTER no sai do programa
		jne 	here
apaga:	mov 	color,00
		push 	ax
		sub 	ah,ah
		mov 	lado,ax
		pop 	ax
		call 	proc1
		mov 	color,02
		cmp 	lado,6dh	;se foi escolhida a tecla para a direita vai ser desenhado o quadrado  direita
		je 		inicio2
		cmp 	lado,6eh	;se foi escolhida a tecla para a esquerda vai ser desenhado o quadrado  esquerda
		je 		inicio1
inicio2:cmp 	inicio,12ch
		jbe 	adiciona
adiciona:add 	inicio,10h	;vai andar 10 casas para a direita

		jmp 	quad1
inicio1:cmp 	inicio,10h
		jge 	subtrai
subtrai:sub 	inicio, 10h	;vai andar 10 casas para a esquerda
		jmp 	quad1

fim:
		mov 	ah,1  		;apenas espera
		int 	21h			;por outra tecla
	
	
		mov 	ah,00h		;prepara para definir o modo grafico
		mov 	al,02h		;repor modo texto.80.25
		int 	10h			;invoca a interrupo 10h 10 da Bios
		pop 	cx
		pop 	dx
		pop 	bx
		pop 	ax
		ret
myproc endp
;#########################################################################################################################
	
proc1 proc near
		push 	ax
		push 	bx
		mov     ax, 10
		call    MsDelay
	
		mov 	bl,0h		;
		mov 	bh,0h		;
	
um:
		mov 	al,bl
		cmp 	al,20		;compara o valor que esta em AL  igual a  20
		jg 		iniciofor2	; salta se for igual a 20
		call 	linha1
		inc 	bl
		jmp 	um
	
							;linhas na vertical
iniciofor2:
		mov 	bl,0h		;inicia for a zero
	
dois:	
		mov 	al,bl		;colocar o valor de bl em al
		cmp 	al,30		;compara se o valor que est no al  igual a 30 
		jg 		iniciofor3
		call 	coluna1
		inc 	bl
		jmp 	dois
	
							;linha horizontal 
iniciofor3:	
		mov 	bl,0		;coloca  o 0 no bl
tres:
		mov 	al,bl
		cmp 	al,20
		jg 		iniciofor4	; salta para inicio4 se for menor  20
		call 	linha2		; seno chama o procedimento linha esquerda, que  para desenhar as linhas
		inc 	bl			;incrementa o bl
		jmp 	tres		;salta para 3
							;++++++++++++++++++++++++linha vertical em comprimentos ao anterior++++++++++++++++++++++++++++++++++++++++
iniciofor4:
		mov 	bl,0h		;inicia  a zero
quatro:
		mov 	al,bl
		cmp 	al,30		; nmero de vezes que faz
		jg 		sair
		call 	coluna2
		inc 	bl
		jmp 	quatro
sair:	pop 	bx
		pop 	ax
		ret
	proc1 endp					
;#########################################################################################################################	
pixel proc near
		push 	dx
		push 	cx
		push 	ax
		mov 	dx,linha	;determina a linha em que comea a cair
		MOV 	CX,quedas	;determina o numero de vezes q vai cair	
Game:
		PUSH 	CX
		MOV 	AL, 02		;pixel cor vermelha
		MOV 	AH, 12
		MOV 	CX, coluna
		INT 	10h	
		;MOV ah, 01
		;INT 21h			;espera por uma tecla
		push 	ax
		mov     ax, nivel
        call    MsDelay
		pop 	ax
		MOV 	AL, 00		;pixel cor preto
		MOV 	AH, 12
		MOV 	CX, coluna	;considerando que temos 300 colunas
		INT 	10h
		inc 	cont		;incrementa o contador
		INC 	DX
		mov 	linha,dx	;guarda a linha em que est
		mov 	quedas,cx	; guarda o numero de vezes que caiu
		POP 	CX
		cmp 	cont,9h
		je 		exit
		Loop 	Game
exit:
		mov 	cont,0
		pop 	ax
		pop 	cx
		pop 	dx
		ret
pixel endp	
;#########################################################################################################################
linha1 proc near
		mov 	al,color	;cor dos pontos vermelho, configura
		mov 	ah,12		;conf int 10h para plot do pixel
		inc 	dx			; vai incrementar o nmero de vezes que for chamado dentro do FOR
		int 	10h			;invoca a int 10h
		ret
linha1 endp
;#########################################################################################################################
linha2 proc near
		mov 	al,color	;cor dos pontos vermelho, configura
		mov 	ah,12		;conf int 10h para plot do pixel
		dec 	dx			; vai decrementar o nmero de vezes que for chamado dentro do FOR
		int 	10h			;invoca a int 10h
		ret
linha2 endp
;#########################################################################################################################
	
coluna2 proc near
		mov 	al,color	;cor dos pontos vermelho, configura
		mov 	ah,12		;conf int 10h para plot do pixel
		inc 	cx			; vai incrementar o nmero de vezes que for chamado dentro do FOR
		int 	10h			;invoca a int 10h
		ret
coluna2 endp
;#########################################################################################################################
coluna1 proc near
		mov 	al,color	;cor dos pontos vermelho, configura
		mov 	ah,12		;conf int 10h para plot do pixel
		dec 	cx			; vai decrementar o nmero de vezes que for chamado dentro do FOR
		int 	10h			;invoca a int 10h
		ret
coluna1 endp
;#########################################################################################################################
MsDelay proc near
; -----------------------------------------------------------
; This proc delays for the specified number of milliseconds.
; It does this by counting memory refresh requests, which
; for AT-class systems are generated by system timer 1,
; normally programmed by the BIOS to generate an output once
; every 18/1193182 = 15.09 microseconds. Each request toggles
; bit 4 of I/O port 61h. We are counting full cycles of the
; bit, with two toggles per cycle, so each cycle takes 30.18
; microseconds and we count 34 cycles for each millisecond.
;
; Call with the number of milliseconds in AX.
;
; Preserves all registers other than AX.
;
; Note that the delay will be much shorter when running
; under the NT versions of Windows.
; -----------------------------------------------------------
		push 	cx

		mov 	cx, ax      ; load msLoop count
msLoop:
		push 	cx          ; preserve msLoop counter
		mov 	cx, 34      ; load repeat count
wait1:
		in  	al, 61h     ; read byte from port
		test 	al, 10h     ; test bit 4
		jz  	wait1       ; jump if bit clear
wait2:
		in  	al, 61h     ; read byte from port
		test 	al, 10h     ; test bit 4
		jnz 	wait2       ; jump if bit not clear
		dec 	cx          ; decrement repeat count
		jnz 	wait1       ; jump if count not zero
		pop 	cx          ; recover msLoop counter
		dec 	cx          ; decrement msLoop count
		jnz 	msLoop      ; jump if count not zero

		pop 	cx
		ret
MsDelay endp
;#########################################################################################################################

END myproc